#include <stdio.h>
#include <dos.h>
#define abs(x) ((x) < 0 ? -(x) : (x))
void Swap(int *pa, int *pb);

void screen(int t)
{
	asm{
		mov ax, t
		int 10h
	}
}

void PutPixel(int x, int y, char c)
{
	y = (y << 6) + (y << 8);
	asm{
		mov    ax, 0xa000
		mov    es, ax
		mov	   di, y
		add    di, x
		mov    bl, c
		mov    es:[di], bl
	}
}

char GetPixel(int x, int y)
{
	char c;
	y = (y << 6) + (y << 8);
	asm{
		mov    ax, 0xa000
		mov    es, ax
		mov	   di, y
		add    di, x
		mov    bl, es:[di]
		mov    c, bl
	}
	return(c);
}


void PutBmp(int x, int y, unsigned char *bitmap, int x_size, int y_size)
{
	int x1, y1;
	unsigned char c;
	for(y1 = 0;y1 != y_size;y1++)
		for(x1 = 0;x1 != x_size;x1++)
		{
			c = bitmap[y1*x_size+x1];
			if(c != 255)
				PutPixel(x1+x, y1+y, c);
		}
}

void GetBmp(int x, int y, char *bitmap, int x_size, int y_size)
{
	int x1, y1;
	char c;
	for(y1 = 0;y1 != y_size;y1++)
		for(x1 = 0;x1 != x_size;x1++)
		{
			c = GetPixel(x1+x, y1+y);
						bitmap[y1*x_size+x1] = c;
		}
}

int LoadBmp(unsigned char *bmp, char *file)
{
	FILE *load;
	int x, y, xmax, ymax;
	if((load = fopen(file, "r")) == NULL)
		return(-1);
	else
	{
		xmax = getc(load);
		ymax = getc(load);
		for(y = 0;y != ymax;y++)
			for(x = 0;x != xmax;x++)
				bmp[y*xmax+x] = getc(load);
	}
	fclose(load);
	return(0);
}

void Line(int x1, int y1, int x2, int y2, char color)
{
	int d, dx, dy;
	int Aincr, Bincr, yincr;
	int x, y;

	if(y2 == y1)
	{
		if(x1 > x2)
			Swap(&x1, &x2);
		for(x = 0;x <= (x2 - x1);x++)
			PutPixel(x1 + x, y1, color);
	}
	else if(x1 == x2)
	{
		if(y1 > y2)
			Swap(&y1, &y2);
		for(y = 0;y <= (y2 - y1);y++)
			PutPixel(x2, y1 + y, color);
	}
	else if((abs(x2 - x1)) > (abs(y2 - y1)))
	{
		if(x1 > x2)
		{
			Swap(&x1, &x2);
			Swap(&y1, &y2);
		}

		if(y2 > y1)
			yincr = 1;
		else
			yincr = -1;

		dx = x2 - x1;
		dy = abs(y2 - y1);
		d = 2 * dy - dx;

		Aincr = 2 * (dy - dx);
		Bincr = 2 * dy;

		x = x1;
		y = y1;

		PutPixel(x, y, color);

		for(x = x1 + 1;x <= x2;x++)
		{
			if(d >= 0)
			{
				y += yincr;
				d += Aincr;
			}
			else
				d += Bincr;
			PutPixel(x, y, color);
		}
	}
	else
	{
		if(y1 > y2)
		{
			Swap(&y1, &y2);
			Swap(&x1, &x2);
		}

		if(x2 > x1)
			yincr = 1;
		else
			yincr = -1;

		dy = y2 - y1;
		dx = abs(x2 - x1);
		d = 2 * dx - dy;

		Aincr = 2 * (dx - dy);
		Bincr = 2 * dx;

		y = y1;
		x = x1;

		PutPixel(x, y, color);

		for(y = y1 + 1;y <= y2;y++)
		{
			if(d >= 0)
			{
				x += yincr;
				d += Aincr;
			}
			else
				d += Bincr;
			PutPixel(x, y, color);
		}

	}
}

void Swap(int *pa, int *pb)
{
	int t;
	t = *pa;
	*pa = *pb;
	*pb = t;
}

void vsync(void)
{
	while (inportb(0x3da) & 0x08);
	while (!(inportb(0x3da) & 0x08));
}
