/*********************************************************\
*	Name:	VERTEX KILLER (project name only!) ver 0.03	  *
*	Author:	Andreas Remar, remar@delta.telenordia.se      *
*	Date:	18/02 - 2000                                  *
*	URL:	http://user.tninet.se/~mql150f				  *
\*********************************************************/

#include "rawgfx.h" // graphics definitions (my own :)
#include "mouse.h"	// mouse definitions	(also my own :)
#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include <dos.h>
#include <stdio.h>

// 3D-define's
#define FOV 256 		// Field Of View
#define xCenter 160
#define yCenter 108
#define zCenter 256
//stars
#define MAXSTARS 500	// number of stars
#define speed 3			// uh...speed of stars...
//shots
#define PLAYER			0
#define ENEMY			1
#define MAXPLAYERSHOTS 	10

class MyFirstEnemy
{
	float currentX, currentY, currentZ;
	float x2D, y2D;
	float x3D, y3D, z3D;
	int active, q;
	struct
	{
		float x, y, z;
	}points[8];
public:
	MyFirstEnemy()
	{
		currentX = currentY = currentZ = active = 0;

		points[0].x = -1; points[0].y = -1;points[0].z = -1;
		points[1].x = -1; points[1].y = -1;points[1].z = 1;
		points[2].x = -1; points[2].y = 1; points[2].z = -1;
		points[3].x = -1; points[3].y = 1; points[3].z = 1;
		points[4].x = 1;  points[4].y = -1;points[4].z = -1;
		points[5].x = 1;  points[5].y = -1;points[5].z = 1;
		points[6].x = 1;  points[6].y = 1; points[6].z = -1;
		points[7].x = 1;  points[7].y = 1; points[7].z = 1;
	}
	MyFirstEnemy(float x, float y, float z, int a)
	{
		currentX = x;
		currentY = y;
		currentZ = z;
		active = a;
	}
	void plot(void)
	{
		currentZ -= speed;
		for(q = 0;q != 8;q++)
		{
			x3D = points[q].x + currentX;
			y3D = points[q].y + currentY;
			z3D = points[q].z + currentZ;

			if(z3D == -zCenter)
				z3D--;
			x2D = FOV * (x3D / (z3D + zCenter)) + xCenter;
			y2D = FOV * (y3D / (z3D + zCenter)) + yCenter;

//			color = 256 - (char)((z3D+256) / 4);
			if((x2D >= 0) && (x2D <= 319) && (y2D >= 16) && (y2D <= 199))
				PutPixel((int)x2D, (int)y2D, 1);
		}
	}
};

class shot
{
	float x, y, z;
	float x2D, y2D;
	int owner, endflag, active;
//	static int number;
public:
	shot()
	{
		x = y = z = owner = endflag = active = 0;
	}
	shot(float startx, float starty, float startz, int startowner)
	{
		x = startx;
		y = starty;
		z = startz;
		owner = startowner;
		endflag = active = 0;
	}
	newvalue(float startx, float starty, float startz, int startowner)
	{
		x2D = (FOV * (x / (z + zCenter)) + xCenter);
		y2D = (FOV * (y / (z + zCenter)) + yCenter);
		if((GetPixel((int)x2D, (int)y2D) == 14))
			PutPixel((int)x2D,(int)y2D, 0);
		x = startx;
		y = starty;
		z = startz;
		owner = startowner;
		active = 1;
		endflag = 0;
	}
	virtual ~shot(){};
	void plot(void)
	{
		if(active)
		{
			x2D = (FOV * (x / (z + zCenter)) + xCenter);
			y2D = (FOV * (y / (z + zCenter)) + yCenter);
			if((GetPixel((int)x2D, (int)y2D) == 14))
				PutPixel((int)x2D,(int)y2D, 0);
			if(owner == PLAYER)
				z += speed;
			else if(owner == ENEMY)
				z -= speed;
//			z+=speed;
			if(z > 255)
			{
				endflag = 1;
				active = 0;
			}
			else
			{
				x2D = (FOV * (x / (z + zCenter)) + xCenter);
				y2D = (FOV * (y / (z + zCenter)) + yCenter);
				if((GetPixel((int)x2D, (int)y2D) != 4))
					PutPixel((int)x2D,(int)y2D, 14);
			}
		}
	}
	int end(void)
	{
		return(endflag);
	}
/*	int numberofshots(void)
	{
		return(number);
	} */
};

class ship
{
	struct {
		float x, y, z;
	} points[25];
	float currentX, currentY, currentZ;
	float x2D[25], y2D[25], x3D, y3D, z3D;
public:
	// constructor
	ship()
	{
		// define all dots in space:
		// 0 - 9
		points[0].x = 0;   points[0].y = -2; points[0].z = 2;
		points[1].x = -1;  points[1].y = -1; points[1].z = 5;
		points[2].x = -1;  points[2].y = -1; points[2].z = 2;
//		points[3].x = -1;  points[3].y = -1; points[3].z = 0;
		points[3].x = .5;  points[3].y = .5; points[3].z = 1;
		points[4].x = 0;   points[4].y = -1; points[4].z = 4;
		points[5].x = 0;   points[5].y = -1; points[5].z = 2;
		points[6].x = 1;   points[6].y = -1; points[6].z = 5;
		points[7].x = 1;   points[7].y = -1; points[7].z = 2;
//		points[8].x = 1;   points[8].y = -1; points[8].z = 0;
		points[8].x = -.5;   points[8].y = .5; points[8].z = 1;
		points[9].x = -2.5;  points[9].y = 0;  points[9].z = 2;
		// 10 - 19
		points[10].x = -1; points[10].y = 0; points[10].z = 7;
		points[11].x = -1; points[11].y = 0; points[11].z = 5;
		points[12].x = -1; points[12].y = 0; points[12].z = 2;
		points[13].x = 1;  points[13].y = 0; points[13].z = 7;
		points[14].x = 1;  points[14].y = 0; points[14].z = 5;
		points[15].x = 1;  points[15].y = 0; points[15].z = 2;
		points[16].x = 2.5;  points[16].y = 0; points[16].z = 2;
		points[17].x = -1; points[17].y = 1; points[17].z = 6;
		points[18].x = -1; points[18].y = 1; points[18].z = 5;
		points[19].x = -1; points[19].y = 1; points[19].z = 2;
		// 20 - 24
//		points[20].x = -1; points[20].y = 1; points[20].z = 0;
		points[20].x = .5; points[20].y = -.5; points[20].z = 1;
		points[21].x = 1;  points[21].y = 1; points[21].z = 6;
		points[22].x = 1;  points[22].y = 1; points[22].z = 5;
		points[23].x = 1;  points[23].y = 1; points[23].z = 2;
//		points[24].x = 1;  points[24].y = 1; points[24].z = 0;
		points[24].x = -.5;  points[24].y = -.5; points[24].z = 1;
		//starting positions
		currentX = 0;
		currentY = 0;
		currentZ = -240;
	}
	void plot(void)
	{
		for(int q = 0;q != 25;q++)
		{
			x3D = (float)points[q].x + currentX;
			y3D = (float)points[q].y + currentY;
			z3D = (float)points[q].z + currentZ;

/*			if(z3D == -zCenter)
				z3D--;*/
			x2D[q] = FOV * (x3D / (z3D + zCenter)) + xCenter;
			y2D[q] = FOV * (y3D / (z3D + zCenter)) + yCenter;

//			color = 256 - (char)((z3D+256) / 4);
/*			if((x2D[q] >= 0) && (x2D[q] <= 319) && (y2D[q] >= 16) && (y2D[q] <= 199))
				PutPixel((int)x2D[q], (int)y2D[q], 1); */
		}
			Line(x2D[0], y2D[0], x2D[4], y2D[4], 4);
			Line(x2D[0], y2D[0], x2D[5], y2D[5], 4);

			Line(x2D[1], y2D[1], x2D[2], y2D[2], 4);
			Line(x2D[1], y2D[1], x2D[6], y2D[6], 4);
			Line(x2D[1], y2D[1], x2D[10], y2D[10], 4);
			Line(x2D[1], y2D[1], x2D[11], y2D[11], 4);

			Line(x2D[2], y2D[2], x2D[7], y2D[7], 4);
			Line(x2D[2], y2D[2], x2D[19], y2D[19], 4);
			Line(x2D[2], y2D[2], x2D[24], y2D[24], 4);

			Line(x2D[3], y2D[3], x2D[8], y2D[8], 4);
			Line(x2D[3], y2D[3], x2D[20], y2D[20], 4);
			Line(x2D[3], y2D[3], x2D[23], y2D[23], 4);

			Line(x2D[6], y2D[6], x2D[7], y2D[7], 4);
			Line(x2D[6], y2D[6], x2D[13], y2D[13], 4);
			Line(x2D[6], y2D[6], x2D[14], y2D[14], 4);

			Line(x2D[7], y2D[7], x2D[20], y2D[20], 4);
			Line(x2D[7], y2D[7], x2D[23], y2D[23], 4);

			Line(x2D[8], y2D[8], x2D[19], y2D[19], 4);
			Line(x2D[8], y2D[8], x2D[24], y2D[24], 4);

			Line(x2D[9], y2D[9], x2D[11], y2D[11], 4);
			Line(x2D[9], y2D[9], x2D[12], y2D[12], 4);

			Line(x2D[10], y2D[10], x2D[11], y2D[11], 4);
			Line(x2D[10], y2D[10], x2D[18], y2D[18], 4);

			Line(x2D[13], y2D[13], x2D[14], y2D[14], 4);
			Line(x2D[13], y2D[13], x2D[22], y2D[22], 4);

			Line(x2D[14], y2D[14], x2D[16], y2D[16], 4);

			Line(x2D[15], y2D[15], x2D[16], y2D[16], 4);

			Line(x2D[17], y2D[17], x2D[19], y2D[19], 4);

			Line(x2D[18], y2D[18], x2D[22], y2D[22], 4);

			Line(x2D[19], y2D[19], x2D[23], y2D[23], 4);

			Line(x2D[20], y2D[20], x2D[24], y2D[24], 4);

			Line(x2D[21], y2D[21], x2D[23], y2D[23], 4);
	}
	void remove(void)
	{
		for(int q = 0;q != 25;q++)
		{
			x3D = (float)points[q].x + currentX;
			y3D = (float)points[q].y + currentY;
			z3D = (float)points[q].z + currentZ;

/*			if(z3D == -zCenter)
				z3D--; */
			x2D[q] = FOV * (x3D / (z3D + zCenter)) + xCenter;
			y2D[q] = FOV * (y3D / (z3D + zCenter)) + yCenter;

//			color = 256 - (char)((z3D+256) / 4);
/*			if((x2D[q] >= 0) && (x2D[q] <= 319) && (y2D[q] >= 16) && (y2D[q] <= 199))
				PutPixel((int)x2D[q], (int)y2D[q], 0); */
		}
			Line(x2D[0], y2D[0], x2D[4], y2D[4], 0);
			Line(x2D[0], y2D[0], x2D[5], y2D[5], 0);

			Line(x2D[1], y2D[1], x2D[2], y2D[2], 0);
			Line(x2D[1], y2D[1], x2D[6], y2D[6], 0);
			Line(x2D[1], y2D[1], x2D[10], y2D[10], 0);
			Line(x2D[1], y2D[1], x2D[11], y2D[11], 0);

			Line(x2D[2], y2D[2], x2D[7], y2D[7], 0);
			Line(x2D[2], y2D[2], x2D[19], y2D[19], 0);
			Line(x2D[2], y2D[2], x2D[24], y2D[24], 0);

			Line(x2D[3], y2D[3], x2D[8], y2D[8], 0);
			Line(x2D[3], y2D[3], x2D[20], y2D[20], 0);
			Line(x2D[3], y2D[3], x2D[23], y2D[23], 0);

			Line(x2D[6], y2D[6], x2D[7], y2D[7], 0);
			Line(x2D[6], y2D[6], x2D[13], y2D[13], 0);
			Line(x2D[6], y2D[6], x2D[14], y2D[14], 0);

			Line(x2D[7], y2D[7], x2D[20], y2D[20], 0);
			Line(x2D[7], y2D[7], x2D[23], y2D[23], 0);

			Line(x2D[8], y2D[8], x2D[19], y2D[19], 0);
			Line(x2D[8], y2D[8], x2D[24], y2D[24], 0);

			Line(x2D[9], y2D[9], x2D[11], y2D[11], 0);
			Line(x2D[9], y2D[9], x2D[12], y2D[12], 0);

			Line(x2D[10], y2D[10], x2D[11], y2D[11], 0);
			Line(x2D[10], y2D[10], x2D[18], y2D[18], 0);

			Line(x2D[13], y2D[13], x2D[14], y2D[14], 0);
			Line(x2D[13], y2D[13], x2D[22], y2D[22], 0);

			Line(x2D[14], y2D[14], x2D[16], y2D[16], 0);

			Line(x2D[15], y2D[15], x2D[16], y2D[16], 0);

			Line(x2D[17], y2D[17], x2D[19], y2D[19], 0);

			Line(x2D[18], y2D[18], x2D[22], y2D[22], 0);

			Line(x2D[19], y2D[19], x2D[23], y2D[23], 0);

			Line(x2D[20], y2D[20], x2D[24], y2D[24], 0);

			Line(x2D[21], y2D[21], x2D[23], y2D[23], 0);
	}
	void movex(float x)
	{
		if((x < 0) && (currentX > -8))
		{
			remove();
			currentX += x;
			if(currentX < -8)
				currentX = -8;
			plot();
		}

		if((x > 0) && (currentX < 8))
		{
			remove();
			currentX += x;
			if(currentX > 8)
				currentX = 8;
			plot();
		}
	}
	void movey(float y)
	{
		if((y < 0) && (currentY > -4))
		{
			remove();
			currentY += y;
			if(currentY < -4)
				currentY = -4;
			plot();
		}
		if((y > 0) && (currentY < 4))
		{
			remove();
			currentY += y;
			if(currentY > 4)
				currentY = 4;
			plot();
		}
	}
	void movez(float z)
	{
		remove();
		currentZ += z;
		plot();
	}
	float posX(void)
	{
		return(currentX);
	}
	float posY(void)
	{
		return(currentY);
	}
	float posZ(void)
	{
		return(currentZ);
	}
};

class stars
{
	struct {
		int x, y, z;
	} stars[MAXSTARS];

	float x2D, y2D, x3D, y3D, z3D;
	int q, drug;
	char color;
public:
	// constructor:
	stars()
	{
		for(q = 0;q != MAXSTARS;q++)
		{
			stars[q].x = random(640) - 320;
			stars[q].y = random(400) - 200;
			stars[q].z = random(512) - 256;
		}
		drug = 0;
	}

	void changepal(int r, int g, int b)
	{
		for(q = 128;q != 256;q++)
		{

			outportb(0x3c8, q);
			outportb(0x3c9, (q/2)*r);
			outportb(0x3c9, (q/2)*g);
			outportb(0x3c9, (q/2)*b);
		}
	}

	void plot(void)
	{
		for(q = 0;q != MAXSTARS;q++)
		{
			x3D = (float)stars[q].x;
			y3D = (float)stars[q].y;
			z3D = (float)stars[q].z;

			if(z3D == -zCenter)
				z3D--;
			x2D = FOV * (x3D / (z3D + zCenter)) + xCenter;
			y2D = FOV * (y3D / (z3D + zCenter)) + yCenter;

			if(GetPixel(x2D, y2D) < 0)
				PutPixel(x2D, y2D, 0);

//			Save this for DrUg-effect:
			if(drug)
			{
				stars[q].x += random(3)-1;
				stars[q].y += random(3)-1;
				x3D = (float)stars[q].x;
				y3D = (float)stars[q].y;
			}
			stars[q].z -= speed;
			z3D = (float)stars[q].z;

			if(z3D == -zCenter)
				z3D--;
			x2D = FOV * (x3D / (z3D + zCenter)) + xCenter;
			y2D = FOV * (y3D / (z3D + zCenter)) + yCenter;

			color = 256 - (char)((z3D+256) / 4);
			if((x2D >= 0) && (x2D <= 319) && (y2D >= 16) && (y2D <= 199) && !(GetPixel((int)x2D, (int)y2D)))
				PutPixel((int)x2D, (int)y2D, color);

			if(z3D < -255)
			{
				if(GetPixel(x2D, y2D) < 0)
					PutPixel((int)x2D, (int)y2D, 0);
				stars[q].x = random(640) - 320;
				stars[q].y = random(400) - 200;
				stars[q].z = 255;
			}
		}
	}
	void drugtoggle(void)
	{
		drug = !drug;
	}
};

char inkey(void)
{
	if(kbhit())
		return(getch());
	else
		return(0);
}

void main(void)
{
	ship Ship;
	stars Stars;
	shot Shots[MAXPLAYERSHOTS];
	MyFirstEnemy sork(0, 0, 0, 1);
	char ch;
	unsigned char logo[32][11];
	int mickeyX, mickeyY, numbershots = 0, freeshots[3] = {1, 1, 1}, LSF = 0;
	unsigned int buttons;
	int q, b1flag = 0;

	LoadBmp(&logo[0][0], "rawfiler\\vertkill.raw");
	randomize();
	screen(0x13);
	printf("     Use the Mouse, Luuk!");
	PutBmp(0, 0, &logo[0][0], 32, 11);
//	Line(0, 0, 319, 0, 4);
//	printf("Vertex Killer!");
	Stars.changepal(1, 1, 1);
	Ship.plot();
	sork.plot();
	do
	{
		ch = inkey();
		if(ch)
		{
			if(ch == 'd' || ch == 'D')
				Stars.drugtoggle();
		}
		mousem(&mickeyX, &mickeyY);
		buttons = bstatus();
		if((buttons & 1) && /*(numbershots < MAXPLAYERSHOTS) && */ (b1flag == 0))
		{
			for(q = 0;q != MAXPLAYERSHOTS;q++)
			{
				if(freeshots[q])
					break;
			}
			if(q < MAXPLAYERSHOTS)
			{
				Shots[q].newvalue(Ship.posX() - 1, Ship.posY() + 1, Ship.posZ() + 6, PLAYER);
				freeshots[q] = 0;
			}
			b1flag = 1;
		}
		else if(!(buttons & 1))
			b1flag = 0;
		if(mickeyX)
			Ship.movex(.01 * (float)mickeyX);
		if(mickeyY)
			Ship.movey(.01 * (float)mickeyY);

		sork.plot();
		Stars.plot();
		for(q = 0;q != MAXPLAYERSHOTS;q++)
		{
			Shots[q].plot();
			if(Shots[q].end() && !freeshots[q])
				freeshots[q] = 1;
		}
		delay(10);
	}
	while(ch != 27);
	screen(0x3);
	printf("Vertex Killer by Andreas Remar (c) 2000\n");
	printf(" remar@delta.telenordia.se\n");
	printf(" http://user.tninet.se/~mql150f\n");
}
